{######################################################}
{##\ ______________________________________________ /##}
{## |                                              | ##}
{## |  autor: Sebastian Stoff                      | ##}
{## |  unit : BASIC - Procedury wspomagajace       | ##}
{## |  ver  : 1.0                                  | ##}
{## |______________________________________________| ##}
{##/                                                \##}
{######################################################}
{$A+,B-,D+,E+,F-,G+,I+,L+,N-,O-,P-,Q-,R-,S+,T-,V+,X+,Y+}
unit Basic;

interface
const t_ = True;
      f_ = False;

function I2S(i : Longint):String;
function PZ(li : Word; dl : Byte):String;
function Rnd(bgn,fin : Integer):Integer;
function InKey(testX,testY,x1,y1,x2,y2 : Integer):Boolean;
procedure Neg(var b : Boolean);
function StringUp(s : String):String;
function GetKey : Word;
procedure CKB;
procedure Beep;
function isvga: Boolean;

implementation
uses Dos, Crt;


function I2S;
var s : String;
begin
  Str(i,s);
  i2s:=s;
end;

function PZ;
var wyn : String;
begin
  Str(li,wyn);
  while Length(wyn)<dl do wyn:='0'+wyn;
  PZ:=wyn;
end;

function Rnd;
begin
  fin:=fin+1;
  Rnd:=Random(fin-bgn)+bgn;
end;

function InKey;
begin
  if (testX>=x1) and (testX<=x2) and (testY>=y1) and (testY<=y2) then InKey:=t_
    else InKey:=f_;
end;

procedure Neg;
begin
  b:=not b;
end;

function StringUp;
var i : Integer;
begin
  for i:=1 to Length(s) do s[i]:=UpCase(s[i]);
  StringUp:=s;
end;

function GetKey;
var r : Registers;
begin
  if KeyPressed then begin
    r.AH:=0;
    Intr($16,r);
    GetKey:=r.AH*256+r.AL;
  end else GetKey:=0;
end;

procedure CKB;
var c : Char;
begin
  while KeyPressed do c:=ReadKey;
  mem[$0040:$001a]:=$1e;
  mem[$0040:$001c]:=$1e;
end;

procedure Beep;
begin
  sound(500);
  delay(100);
  nosound;
end;

function isvga; assembler;
asm
  mov ah, $12
  mov al, 0
  mov bl, $36
  int $10
  cmp al, $12
  jne @kon
  mov al, 1
  jmp @out
@kon:
  mov al, 0
@out:
end;

end.